
#include <vector>
#include <iomanip>
#include <fstream>
#include <vector>
#include <cmath>
#include <iostream>
#include <sstream>

using namespace std;

// ----------------------------------------------------------------------------------------
// read in matrix / nmr data of variable size
   std::vector< std::vector<double> > fileIn( const char* filename )
{
   std::vector< std::vector<double> > arr;
   ifstream in( filename );
   if ( in )
   {
      for ( string line; getline( in, line ); )
      {
      if( (line[0] == '#') | (line[0] == '&') | (line.empty()) | (line[0] == '\n') ) continue; // skip #, & and empty lines 
         stringstream ss( line );
         std::vector<double> row;
         for ( double i; ss >> i; ) row.push_back( i );
         arr.push_back( row );
      }
   }
   else
   {
      cerr << "No such read-in file\n";
   }
   return arr;
}

// ----------------------------------------------------------------------------------------
   
  void print_time ( const vector<vector<double>> &A)
  {
  for( long unsigned int i = 0 ; i < A.size() ; i++ )    {
    cout << fixed << setw(8) << setprecision(6) <<  A[i][0] << " " ;
    cout << endl ;
        }
  }

// ----------------------------------------------------------------------------------------
// print initial data 

  void print_dat ( const vector<vector<double>> &A)
  {
  for( long unsigned int i = 0 ; i < A.size() ; i++ )    {
  for( long unsigned int j = 0 ; j < A[i].size() ; j++ ) {
    cout << fixed << setw(8) << setprecision(6) <<  A[i][j] << " " ;
        }
                cout << endl ;
    }
  }

// ----------------------------------------------------------------------------------------


