
#include <vector>
#include <iomanip>
#include <fstream>
#include <vector>
#include <cmath>
#include <iostream>
#include <sstream>
#include <dlib/optimization.h>

using namespace std;

// ----------------------------------------------------------------------------------------
// read in matrix / nmr data of variable size
   std::vector< std::vector<double> > fileIn( const char* filename )
{
   std::vector< std::vector<double> > arr;
   ifstream in( filename );
   if ( in )
   {
      for ( string line; getline( in, line ); )
      {
      if( (line[0] == '#') | (line[0] == '&') | (line.empty()) | (line[0] == '\n') ) continue; // skip #, & and empty lines 
         stringstream ss( line );
         std::vector<double> row;
         for ( double i; ss >> i; ) row.push_back( i );
         arr.push_back( row );
      }
   }
   else
   {
      cerr << "No such read-in file\n";
   }
   return arr;
}
// ----------------------------------------------------------------------------------------
struct Point
{
    double x;
    double y;
};

// ----------------------------------------------------------------------------------------
// Any distance function can be used for optimisation.  This one, where we want
// to find the least-squares is most common. 
double dist(double y1, double y2)
{
    double y = y2 - y1;
    return (y * y);
}

// ----------------------------------------------------------------------------------------
   
  void print_time ( const vector<vector<double>> &A)
  {
  for( long unsigned int i = 0 ; i < A.size() ; i++ )    {
    cout << fixed << setw(8) << setprecision(6) <<  A[i][0] << " " ;
    cout << endl ;
        }
  }

// ----------------------------------------------------------------------------------------
// print initial data 
  void print_dat ( const vector<vector<double>> &A)
  {
  for( long unsigned int i = 0 ; i < A.size() ; i++ )    {
  for( long unsigned int j = 0 ; j < A[i].size() ; j++ ) {
    cout << fixed << setw(8) << setprecision(6) <<  A[i][j] << " " ;
        }
                cout << endl ;
    }
  }


// ----------------------------------------------------------------------------------------
// convert to dlib matrix
// define number of rate constants as needed (start from 0 for first one) 
  dlib::matrix<double, 0 , 1 > vec2matrix ( const vector<vector<double>> &V )
  {
  dlib::matrix<double, 0 , 1 > C ;
  for( long unsigned int i = 0 ; i < V.size() ; i++ )    {
  for( long unsigned int j = 0 ; j < V[i].size() ; j++ ) {
    C(i,j) = V[i][j] ;
        }
    }
  return C ;
  }


